<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
/**
 * A system configuration manager
*/
class Core_Config {
	private $CONFIG = array ();
	private $CONFIG_FILE = '';
	private static $instance = false;
	
	private function __construct () {
		$CONFIG = array();
		$this->CONFIG_FILE = CONFIG_DIR.'system.config.php';
		@include $this->CONFIG_FILE;
		$this->CONFIG = $CONFIG;
	}
	
	/**
	* Returns configuration variable
	* 
	* @param mixed $name Variable name
	* @return mixed
	*/
	public function Get ($name) {
		return isset ($this->CONFIG[$name]) ? unserialize($this->CONFIG[$name]) : '';
	}
	
	/**
	* Sets configuration variable
	* 
	* @param mixed $name
	* @param mixed $value
	* @return mixed
	*/
	public function Set ($name, $value) {
		if (gettype ($name)!='string') {
			return false;
		}
		$this->CONFIG[$name] = serialize($value);
		return $this->writeConfig();
	}
	
	/**
	* Removes configuration variable
	* 
	* @param mixed $name Variable name
	* @return bool
	*/
	public function Remove ($name) {
		if (isset($this->CONFIG[$name])) {
			unset ($this->CONFIG[$name]);
			return $this->writeConfig();
		} else {
			return false;
		}
	}
	
	/**
	* Saves configuration data to file
	* 
	*/
	private function writeConfig() {
		$str = '<?php ';
		foreach ($this->CONFIG as $name=>$value) {
			$str .= '$CONFIG[\''.addslashes($name).'\'] = "'.addslashes($value).'"; '.Tools_Filesystem::eol;
		}
		$str .= ' ?>';
		$res = Tools_Filesystem::writeFile ($this->CONFIG_FILE, $str, Tools_Filesystem::fs_rewrite);
		return (bool) $res;
	}
	
	/**
	* Returns Config instance
	* 
	*/
	public static function getInstance() {
		if (!self::$instance) {
			self::$instance = new self();
		}
		return self::$instance;
	}
}

$Config = Core_Config::getInstance();
